= Release 2.18.0 =

This version drops support for all Windows versions < 10.

TortoiseGit not longer ships Notepad2e any more, but now defaults to Windows Notepad that also supports LF EOL.
If you want to use Notepad2e, you will need to set it up manually (<https://github.com/ProgerXP/Notepad2e>)
and configure it in TortoiseGit settings as alternative editor.

Git for Windows is going to stop providing builds for 32-bit Windows, TortoiseGit will follow suit with one of the next releases.

== Features ==
 * Fixed issue #3826: Help links don't open in a sensible browser
 * Update TortoiseGitPlink to PuTTY Plink 0.82
 * Update shipped PuTTY binaries to 0.82
 * Update Scintilla to 5.5.4 and Lexilla to 5.4.2
 * Update libgit2 to 1.9.0

= Release 2.17.0.2 =
Released: 2024-11-01

This is the last version that will work on Windows 7 and 8 (and possibly 8.1).

The TortoiseGit 2.17.0.1 installer was missing statically linked x86 libraries for the x64 build.

== Bug Fixes ==
 * Fixed issue #4177: TortoiseGit dialogs may not be visible (when a modal sub dialog is shown too early during dialog initialization)
   This reverts the fix for issue #4118: When dark mode is enabled, dialogs momentarily flicker with "light mode" UI elements on opening

== Known issues ==
 * Issue #4013: Incorrect info displayed in title bar of Windows Explorer windows
   At the moment the numbers are only updated when the index or the current branch change.

= Release 2.17.0 =
Released: 2024-10-30

This is the last version that will work on Windows 7 and 8 (and possibly 8.1).

== Features ==
 * Updated pcre2 to 10.44
 * Update editorconfig to 0.12.9
 * Update Scintilla to 5.5.3 and Lexilla to 5.4.1
   Touchpad horizontal scroll direction has been adjusted to match other Win32 applications
 * Updated libgit to version 2.46.2 based on Git for Windows sources
 * Updated libgit2 to 1.8.2pre
 * Fixed issue #4143: BrowseRefsDlg: Order the branches by commit date instead of date (add committer name/date columns)
 * Fixed issue #4147: Allow sorting Log view by `--author-date-order`
 * Fixed issue #4137: "Detach" option ignored when making a new worktree
 * Fixed issue #3904: TortioiseGitMerge doesn't remember View/Bars settings

== Bug Fixes ==
 * Fixed issue #4132: Error "Could not get next commit. libgit returns: -4" in Log Messages dialog on commit with author date 1970-01-01T00:00:00Z
 * Fixed issue #4126: Capitalize the first letter in the Push dialog
 * Fixed issue #4133: libgit2 returned: failed to parse revision specifier (ref ending with an `@` character)
 * Fixed issue #4141: Cannot remove remote: "usage: git remote remove <name>"
 * Fixed issue #4145: "Push default" option for remote resetted after adding a new remote
 * Fixed issue #4159: Closing the git log window crashes TortoiseGit on Windows 7
 * Fixed issue #4140: TortoiseGitMerge Dark mode flashes white when maximized
 * Fixed issue #4148: Dialogs 1 doesn't have documentation for the Default limitation of log messages fields
 * Fixed issue #4075: Dark theme revision graph text color contrast too low
 * Fixed issue #4165: Changing rebase settings during rebase can corrupt commit (squash after finishing edit)
 * Fixed issue #3995: Dark theme - selected items not visible
 * Fixed issue #4170: git-svn checkout ignores -T trunk or other options
 * Fixed issue #4118: When dark mode is enabled, dialogs momentarily flicker with "light mode" UI elements on opening
 * Fixed issue #4174: Fix double words typo
 * Fixed issue #4173: Escape key stops working in Switch/Checkout dialog after browsing branches

= Release 2.16.0 =
Released: 2024-04-30

Support for Windows 7 and 8 will be dropped with one of the next releases.

Contains a fix for a critical vulnerability (CVE-2024-31497) in PuTTY with 521-bit ECDSA keys, see notes for release 2.15.0.1.

== Features ==
 * Updated OGDF to 2023.09 (Elderberry)
 * Update Scintilla to 5.5.0 and Lexilla to 5.3.2
 * Updated zlib to 1.3.1
 * TortoiseGitMerge: Add ignore line endings button to Ribbon
 * Allow BugTraq "Select issue"-button at the same time as the textbox
 * Add support for GIT_TEMPLATE_DIR environment variable
 * Updated libgit to 2.43 based on Git for Windows sources
 * Updated libgit2 to 1.8.0
   libgit2 now supports worktree config
 * Updated pcre2 to 10.43
 * Update json library to 3.11.3
 * Update editorconfig to 0.12.7
 * Fixed issue #3881: Compare Revisions - Revert - can not undo an Add action
 * Fixed issue #4097: Revert to parent version menu missing for added files in Log Viewer
 * Fixed issue #4112: After conducting a 'hard' reset, "git clean" should be offered
 * Fixed issue #3325: Display repository name first in window title
   Can be controlled using the DialogTitles advanced setting.
 * Fixed issue #3981: Add stash controls to the Switch/Checkout progress dialog
 * Fixed issue #4015: Add --force option for worktree remove

== Bug Fixes ==
 * Fixed issue #4085: ImportPatch is closing even click "NO"
 * Fixed issue #4082: TortoiseGitMerge: Particular usage undo/redo function casue exception/freeze window
 * Fixed issue #4086: ResolveDlg: Merge conflict file gets changed after fixing merge and pressing Resolve
 * Fixed issue #3917: Git not getting LFS files (SSHAskPass not showing)
 * Fixed issue #4083: TortoiseGitMerge: Infinite loop when diff file has only 1 line and perform "Redo"
 * Sanitize GIT_* environment variables to prevent passing environment variables to git.exe that are currently unsupported in TortoiseGit/libgit2 to prevent inconsistencies
 * Fixed issue #4096: Git configuration under XDG_CONFIG_HOME is not recognized correctly
 * TortoiseGitBlame: Fix blaming a file from another working tree
 * Fixed issue #4073: TortoiseGit extremely slow on network shares / UNC paths since 2.14
 * Fixed issue #4106: Submodule Update with force not working when using the Git Sync Dialog
 * Fixed issue #4110: TortoiseGitMerge: Ribbon becomes empty after maximizing on Windows 11
 * Fixed issue #4004: TortoiseGit closes window after commit when pressing push when the owning explorer window has been closed
 * Fixed issue #3909: App freezes when pasting from a closed logs window
 * Fixed issue #3959: The slash direction of the abbreviated path displayed in the dialog box is different
 * Fixed issue #4122: TortoiseGitMerge "Encountered an improper argument" error message

= Release 2.15.0.1 =
Released: 2024-04-15

PuTTY 0.81 fixes a critical vulnerability CVE-2024-31497 in the use of 521-bit ECDSA keys (ecdsa-sha2-nistp521). If you have used a 521-bit ECDSA private key with any previous version of PuTTY, consider the private key compromised: remove the public key from authorized_keys files, and generate a new key pair.

However, this only affects that one algorithm and key size. No other size of ECDSA key is affected, and no other key type is affected.

== Bug Fixes ==
 * Update TortoiseGitPlink to PuTTY Plink 0.81
 * Update shipped PuTTY binaries to 0.81

= Release 2.15.0 =
Released: 2023-10-03

Support for Windows 7 and 8 will be dropped with one of the next releases.

== Features ==
 * Fixed issue #4027: Autocompletion doesn't handle JS classes
 * Updated libapr to 1.7.4
 * Updated libapr-util to 1.6.3
 * Updated pcre2 to 10.42
 * Updated libgit to 2.40.1 based on Git for Windows sources
 * Updated libgit2 to 1.7.1
 * Updated zlib to 1.3
 * Update TortoiseGitPlink to PuTTY Plink 0.79
 * Update shipped PuTTY binaries to 0.79
 * Fixed issue #3974: Windows 11 Context Menus only display in single user when has multiple users
   Added a button to register the win11 context menu for the current user in TortoiseGit settings on the Windows 11 contextmenu page
 * Update Scintilla to 5.3.6 and Lexilla to 5.2.7
 * Fixed issue #3435: Dramatically speed up revert operations
 * Fixed issue #3053: "Abort" button in merge conflict dialogue is misleading -> opens Abort merge dialog now
 * Fixed issue #4034: After git lfs lock, UI suggest a pull
 * Allow the dark mode to be always enabled if possible (e.g., using Ctrl+Alt+D)
 * Add support for SVG files in TortoiseGitIDiff
 * Fixed issue #4033: Add workaround for broken scoop shim
 * Lots of refactorings and performance optimizations
 * Fixed issue #4040: TortoiseGitBlame: Ability to select multiple commits (line highlighting)
 * Make TortoiseGitMerge and SSHAskPass multi-monitor DPI aware
 * Fixed issue #3698: "Resolve conflict using theirs" is extremely slow
 * Update editorconfig to 0.12.6
 * Fixed issue #3745: Support show log for both A..B and B..A
 * Fixed issue #2754: Add hint for pressing F5 for Refresh in TortoiseGit Commit window

== Bug Fixes ==
 * Fixed redraw bug in log list
 * Fixed issue #3843: 'Revert' does not work for submodules
 * Fixed issue #4030: TortoiseGitMerge Dark mode flashes white when opening
 * Fixed issue #4041: Git Worktree Add command error 129 when directory path contains spaces
 * Improved Cygwin and Msys2 compatibility
 * TortoiseGitMerge: Fixed optical glitch if wrap mode is enabled with non-ASCII files
 * Fixed issue #4049: Diff with previous version - ENTER closes dialog
 * Fixed issue #4051: Copy ref names in nested view does not copy full ref name
 * Fixed issue #3373: Refresh log after shallow clone depth update
 * Improve crash resistance in log dialog on broken repositories
 * Fixed issue #4057: "Clean up" fails to delete files with Unicode characters in name if core.quotepath is not explicitly set
 * Fixed issue #4058: Performance issue when the Git index contains a large number of files
 * Fixed issue #3874: TortoiseGitMerge GUI elements overlap with Ribbon on Windows 7

= Release 2.14.0.1 =
Released: 2023-04-15

== Bug Fixes ==
 * Fixed issue #3997: TortoiseGit crashes with "libgit2 returned: failed to get security information: Incorrect function."

= Release 2.14.0 =
Released: 2023-02-05

== Features ==
 * Fixed issue #3860: Highlight keywords, such as error, fatal and warning in output of git commands
 * Update Scintilla to 5.3.2 and Lexilla to 5.2.1
 * Allow to see diff to previous commit on commit dialog for merge commits
 * Update libgit to 2.37.5 based on Git for Windows sources
 * Update libgit2 to 1.5.0
 * Update OGDF to version 2022.02
 * Fixed issue #3873: Submodule Add Dialog does not automatically grab the Git Clone link from the clipboard
 * Update zlib to 1.2.13
 * Update pcre2 to 10.40
 * Update hunspell to 1.7.2
 * LogDlg: Prevent the graph from drawing an unfinished line for each ignored parent on first-parent only walk
 * Update shipped PuTTY binaries to 0.78
 * Update TortoiseGitPlink to PuTTY Plink 0.78
 * Update TortoiseOverlays to 1.1.5
 * Fixed issue #3932: RebaseDlg: Remember last selection of 'add "cherry picked from"'
 * Fixed issue #3938: Add Switch/Checkout... option after fetch
 * Fixed issue #3935: Submodule update is slow for repositories with several submodules
 * Fixed issue #3797: Add additional information to the Windows Explorer title
 * Fixed issue #3937: Support worktree operations (Add, remove, lock, unlock, prune) and worktree list
   Worktrees can also be created by drag'n'drop of a repository root directory
 * Fixed issue #3903: Wrong (empty) icon in Windows 11 taskbar
 * Fixed issue #3867: GitLog does not show super project pointers in conflicted submodule
 * Fixed issue #3789: Commit dialog: Amend Last Commit in Message section unclear
 * Fixed issue #3958: Pasting a path in the input box should automatically trim the quotes
 * Improved parsing Git URLs/branch names from clipboard for push/pull/fetch dialgos
 * CommitDlg: Allow to see diff to previous commit also for merge commits
 * Add special environment variable "TGIT_INITIATED_CALL" to indicate that a git.exe call was issued from TortoiseGit
 * Add initial support for ARM64 (with separate MSI installer)
 * Fixed issue #3996: Improve compatibility with Win32-OpenSSH (Git hanging on waiting passphrase from stdin)
 * Fixed issue #3994: LogDlg: Allow to open new log dialog

== Bug Fixes ==
 * Fixed issue #3865: Ampersand in branch name not shown in Windows context menu
 * Fixed issue #3868: 2.13 has bug for clone without checkout
 * Fixed issue #3863: "Push..." menu item in the log window context menu does not honor last selection of pushing all branches
 * Fixed issue #3870: Dialog after "Bisect reset" offers bisect step options
 * Removed right anchor from "Staging Support" checkbox on commit dialog
 * Fixed issue #3905: TortoiseGitMerge doesn't apply Settings/Colors/Misc/Whitespaces
 * Fixed issue #3900: Adjust min. height of Log Message dialog
 * Fixed issue #3929: commit window handles double-click strangely
 * Fixed issue #3926: TortoiseGitMerge undo/redo can cause window to become unresponsive
 * Fixed issue #3930: TortoiseGitMerge optimized docking PatchFileView
 * Fixed issue #3927: Support deleted files for "Compare two files"
 * Fixed issue #3911: TortoiseGitMerge: "The text is identical ..." dialog causes display issues
 * Fixed issue #3940: restore scroll position of list
 * Fixed issue #3906: Pull dialog always defaults to the wrong branch in submodules
 * Fixed issue #3897: Bisect refs are incorrect when working with worktrees
 * Fixed issue #3952: Log window wrong branch after cherry pick if switched after log window brought up
 * Fixed issue #3953: Disabling ShowListFullPathTooltip doesn't hide tooltips in Changed Files dialog
 * Fixed issue #3945: "Combine to one commit" sometimes broken
 * Fixed issue #3663: Wrong window has focus after pull
 * Fixed issue #3956: Sometimes rebase contains wrong list of files
 * LogDlg: Prevent the graph from drawing an unfinished line for each ignored parent on first-parent only walk
 * Start TGit processes without identity from the shell extension
   Related issues: issue #3889, issue #3949
 * Fixed issue #3967: Show log for submodule from compare revisions dialog
 * Fixed issue #3975: Windows 11 context menu not working after Windows 11 upgrade

= Release 2.13.0.1 =
Released: 2022-02-06

== Bug Fixes ==
 * Fixed issue #3856: Documentation Problem - Rebase needs more info and accurate info for setting upstream from CLI
 * Fixed issue #3855: Shell integration broken after upgrade to 2.13 (on Windows < 10)
 * Fixed issue #3859: Incorrect count of removed files if some files do not exist
 * Fixed issue #3857: Log Messages filter breaks Russian characters on pasting

= Release 2.13.0 =
Released: 2022-01-31

== Changes ==
 * Git (for Windows) 2.24 or newer is now required

== Features ==
 * Update Scintilla and Lexilla to 5.1.0
 * Fixed issue #3744: Update TortoiseGitPlink to PuTTY 0.76 and shipped binaries to PuTTY 0.76
 * Fixed issue #2379: "Show changes as unified diff" from Commit window on N files opens N diff windows
 * Fixed issue #3738: Added force flag on LFSLocksDlg
 * Fixed issue #2299: Better support the git staging process
 * Update libgit2 to 1.3.0
 * Update pcre2 to 10.39
 * Update editorconfig to 0.12.5
 * Update libgit to 2.32.0 based on Git for Windows sources
 * Fixed issue #3764: Add TortoiseGit menu to the right click menu in Windows 11
 * Fixed issue #3818: Change icon image for Cherry-Pick
 * Fixed issue #3728: Log Browser: Add an option to switch on full history (--full-history)
 * Fixed issue #2562: Automatically track remote when pushing untracked branch
 * Add support for Ctrl+A in BrowseRefsDlg and RepositoryBrowser
 * Fixed issue #3820: "Stash changes" should not offer stash pop/apply after no changes were stashed
 * Fixed issue #3812: Extend `:rebase` command with additional parameters
 * Fixed issue #3702: "Push all branches" should be unchecked when Push command is issued with a specific branch
 * Allow to keep changelists after committing
 * Fixed issue #3602: Make it possible to select multiple old commit messages from log history
 * Fixed issue #3782: Stash window may operate on unwanted stash under some circumstances when view is not refreshed
 * Fixed issue #3661: Exit code of TortoiseGitMerge should be based on success of a merge resolution
 * Fixed issue #3741: In `Browse Refs` show `gone` for branches tracking remote branches that have been deleted
 * TortoiseGitMerge: Correctly handle BOM changes to files when applying patches
 * Fixed issue #3787: Implement expanding/collapsing nodes in the log tree on demand
 * Fixed issue #3692: 64-bit version should bundle 64-bit pageant (and maybe other PuTTY binaries)

== Bug Fixes ==
 * Fixed issue #3736: LFS force unlock not working
 * Fixed issue #3740: Setting DownloadAnimation=false has no effect, the turtle still flies
 * Remove extra space in front of Log Messages when drawing labels on right side
 * Fixed issue #3750: Dramatic speedup saving of large files from TortoiseMerge
 * Fixed issue #3781: TortoiseGitMerge Redo is not recorded as change
 * Fixed issue #3794: "Submodules" option is truncated in the "Clean up" dialog
 * Fixed issue #3813: Filter is checking for '%' incorrectly
 * Fixed issue #3779: "Show branches this commit is on" ("References commit is on" window) takes a very long time to find branches and tags
 * Fixed issue #3808: LFS stopped working (maybe related to major upgrade of git-lfs 3.x)
 * Fixed issue #3822: Crash (0xc0000409) in TortoiseGitProc.exe when invoking git log
 * Fixes issue #3826: Help links to TortoiseGit site don't open in a sensible browser
 * Fixed issue #3815: TortoiseGitMerge crashes on Windows 7 on startup when winrt libraries are installed
 * Fixed issue #3831: TortoiseGitMerge omits text after null byte when word wrap is enabled
 * Fixed issue #3799: Display of Long lines with Chinese characters is truncated in TortoiseGitMerge dialog
 * Fixed issue #3836: TortoiseGitMerge: With line wrapping enabled, show the current column as in the wrapped line, not as the visible column
 * Fixed issue #3837: TortoiseGitMerge support link is outdated
 * Fixed issue #3834: Log window hangs on pasting wrong SHA-1 into commit log list when "working tree changes" are selected
 * Fixed issue #3793: "Diff with previous version" dialog does not clear files list during validation / for invalid version
 * Fixed issue #3784: Rebase dialog does not ask to pop stash when post rebase options in the lower left are used
 * Fixed issue #3625: Commit dialog shows wrong branch after committing failed when new branch was specified
 * Fixed issue #3658: Cannot "format-patch" from stash
 * Fixed issue #3791: TortoiseGitMerge: Ensure the line has an EOL unless it's the end of the document
 * Fixed issue #3790: TortoiseGitMerge: Prevent calling "mark as resolved" twice
 * Fixed issue #3765: TortoiseGitMerge crashes with files larger than 1GB
 * Fixed issue #3826: Help links to TortoiseGit site don't open in a sensible browser
 * Fixed issue #3770: TortoiseGitMerge can't apply NonANSI (e.g., UTF-8) patch
 * Fixed issue #3708: Log window becomes unresponsive when selecting commit with large file list
 * Fixed issue #3833: LogDlg: Access violation in gitdll when multi-pack-index exists
 * Fixed issue #3846: ScanFile hangs commit dialog (fixed regex backtracking)
 * Fixed issue #3848: "Git Sync..." > "Compare tags" does not properly clear state from previous actions
 * Fixed issue #3849: TortoiseGitMerge cannot drag mouse to select last character of wrapped line
 * Fixed issue #3854: Ampersand in branch label underlines next character

= Release 2.12.0 =
Released: 2021-03-31

== Changes ==
 * Fixed issue #3631: Log: filtering commits by file path does not work if slash is used as path separator
   The Log Dialog now uses only the Git path (with slashes) for filtering. This is now consistent with other path filters in TortoiseGit.
 * Ctrl+Enter is assigned for the default button (Start Rebase, Amend, Commit, or Done) in the Rebase/Cherry-Pick dialog. This is now consistent with the Commit dialog.

== Features ==
 * Fixed issue #3654: Allow to completely disable the turtle animation, added TortoiseGit advanced setting "DownloadAnimation"
 * Update libgit to 2.30.2 based on Git for Windows sources
 * Update libgit2 to 1.1.0
 * Update Scintilla to 4.4.6
 * Allow multiple ref selection in the Revision Graph Filter
 * Move prune (all remotes) setting to git config page
 * Update pcre2 to 10.36
 * Fixed issue #3693: Make short hash length for hyper-link in log message configurable
 * Fixed issue #3705: No "Move to Changelist" option in check for modifications dialog
 * Fixes issue #3695: Keep the current line in the view when resizing with line-wrap on in TortoiseGitMerge
 * Switch dialog: Remember last state of the "Create New branch" checkbox state for switching to a tag or commit
 * Fixed issue #3181: Branch dialog: Create branch should remember "switch to" state
 * Fixed issue #3700: Resolve the conflicts did not show the merge_head with correct branch name
   The branch detection heuristic can now be disabled using the advanced setting "ConflictDontGuessBranchNames".

== Bug Fixes ==
 * Fixed issue #3649: "multi-project pull/fetch/push" not working
 * Fixed issue #3652: Clone: Auto fill from clipboard with URLs with quotes fails
 * Fixed issue #3651: View Patch window shrinks each time it opens with high DPI
 * TortoiseGitMerge: Make column index 1 based as most editors are 1-based instead of instead of 0 based
 * Fixed issue #3662: LogDlg: The "Compare change sets" command is not shown when two commits are adjacent on the list
 * Fixed issue #3664: revert dialog in dark mode shows file list black
 * Fixed issue #3668: "Revert to revision" fails for added files
 * Fixed issue #3678: Remove deprecated git lfs clone option from clone dialog
 * Fixed issue #3674: Missing "Add to ignore list" menu on the "Show Log" dialog
 * Fixed issue #3517: Revision graph filter does not work
 * Fixed issue #3685: The entered message erased by Amend Last Commit checkbox cannot be retrieved
 * Fixed issue #3686: Explorer hangs on dead network drives
 * Fixed issue #3696: Compare dialog (FileDiffDlg.cpp) should hide files with only ignored changes
 * Fixed issue #3704: Changed Files Dlg: "Revert to revision" fails for renamed files
 * Fixed issue #3694: No overlay if not all lower case in repo top folder in WSL2 filesystem

= Release 2.11.0 =
Released: 2020-10-10

== Bug Fixes ==
 * Fixed issue #3593: Statistics dialog - misaligned controls
 * Fixed issue #3598: TGitCache blocks repository directory to be truly deleted
 * Fixed issue #3619: Hook settings always reset "Hide the script while running" to checked for hooks stored in .tgitconfig
 * Fixed issue #3617: 'Saving config failed (key: "fetch.prune", value: "")' in remote repository definition when `fetch.prune` is set in global config
 * Fixed issue #3632: Log dialog: Message box with the text "git_get_commit_from_hash failed for 00...00" appears in certain situations
 * Fixed issue #3638: Better handling of trying to set an upstream branch not set to be fetched in the remote

== Features ==
 * Update Scintilla to 4.4.5
 * Fixed issue #3348: Showing line and column number in the status line of TortoiseGitMerge
 * Fixed issue #3408: TortoiseGitMerge: When double clicking on a word, mark the word only in the current view if also the Ctrl key is pressed
 * TortoiseGitMerge: Show the number of marked words in the status bar
 * Fixed issue #2101: Tortoise(Git)Merge - 'find' workflow suggested enhancement: Add "Search next" and "Search previous" to the ribbon
 * Fixed issue #3568: Add support for Git repository version 1
 * Fixed issue #3605: TortoiseGitProc branch command is not documented and does not handle /name parameter
 * Update pcre2 to 10.35
 * Fixed issue #3589: Added dark mode support to all TortoiseGit tools, needs to be separately enabled
   Dark mode can only be enabled for Windows 10 1809 and later when Windows dark mode is activated.
   This also improves the high contrast mode.
 * Allow to diff a file in Log/RepositoryBrowser with file selected by "Diff later" in Explorer
 * Fixed issue #3362: Ease searches in the log window (auto select text)
 * Fixed issue #3539: doesn't abort commit if user doesn't modify the template commit message
 * Fixed issue #3233: Change the dialog font to "Segoe UI", which is the default font for most Windows dialogs, including Explorer
 * Fixed issue #1274: Allow log font to be used for LogListCtrl and FileListCtrl
   Needs to be enabled explicitly in TortoiseGit advanced settings using LogFontForFileListCtrl resp. LogFontForLogCtrl
 * Fixed issue #3282: Prefs and Docs - UDiff should have a link back to Diff Viewer section
 * Update TortoiseGitPlink to PuTTY Plink 0.74
 * Update shipped PuTTY binaries to 0.74
 * Update libgit2 to 1.0
 * Implement very simple multi-project pull/fetch/push
 * Fixed issue #3183: Add support for git lfs lock/unlock
 * Fixed issue #3636: Commit Window new branch should focus textbox
 * Fixed issue #3312: Add --push-option to push dialog
 * Fixed issue #3641: Remove default behavior to create a branch when switching to a tag

= Release 2.10.0.2 =
Released: 2020-03-24

== Bug Fixes ==
 * Fixed issue #3557: TortoiseGitMerge 'Use this text block' not working
 * Fixed issue #3559: TortoiseGitMerge loses text selection when you open the context menu by right-clicking
 * Build with VS2019 16.4 again to circumvent code-gen-issues

= Release 2.10.0.1 =
Released: 2020-03-19

== Bug Fixes ==
 * Fixed issue #3525: LogDlg crashes on copying full log info
 * Fixes issue #3527: TGit always crashes when commiting an edit after opening the "Onto" dialog
 * LogDlg: Improve high contrast mode switching
 * Fixed issue #3535: `Show log ID instead of SHA-1` might cut of numbers
 * Fixed issue #3531: TortoiseGitMerge: the captured to clipboard text is two characters shorter than the selected
 * Fixed issue #3543: Push can't run TortoiseGitPlink.exe with Cygwin hack enabled
 * Fixed issue #3542: Commit many files not working with Cygwin hack enabled
 * Fixed issue #3524: Revision Graph very slow after update to 2.10.0.0
 * Fix possible crash on Git credential helper settings page
 * Fixed possible data races in sync dialog

= Release 2.10.0 =
Released: 2020-03-01

== Features ==
 * Fixed issue #3448: Revision Graph: Make direction of arrows configurable
 * Fixed issue #3263: Compare parent revision with working tree
 * Update Scintilla to 4.2.3
 * Update libgit2 to 0.99
 * Fixed issue #3481: Add Switch/Checkout to Tags and Refs in Revision Graph
 * TGitCache: Cache libgit2 config (reduce disk access)
 * The Setting "Use .mailmap" is now honored everywhere in TortoiseGit (e.g., TotoiseGitBlame, GitWCRev)
 * Enable Mailmap by default (Git 2.23 also enabled it by default)
 * Fixed issue #3494: External Merge tool trustExitCode
   An external merge tool can now be executed synchronous (ie, TortoiseGit blocks while it's running): After the exit of the merge tool TortoiseGit automatically removes the temporary files and asks whether to mark the conflict as resolved.
 * Fixed issue #3470: Be able to switch branch from the Sync dialog
 * FileDiffDlg: Add patch dialog
 * Improved UDiff search
 * PullFetchDlg: Allow to select remote references (using ls-remote)
 * Add optional support for the Windows 8+ spell checker (needs to be enabled in Advanced Settings using the key "Win8SpellChecker" at the moment; if enabled it will be tried first, cf. manual)
 * Speed up RebaseDlg and SyncDlg by asynchronously calculating the file diff
 * Update libgit to 2.25.1 based on Git for Windows sources
 * Fixed issue #3452: Mouse wheel scroll does not work when mouse over author names in TortoiseGitBlame
 * Performance optimizations
 * Build with Visual Studio 2019

== Bug Fixes ==
 * Fixed issue #3449: Crash when indenting short lines (pressing tab key)
 * Fixed issue #3463: Check For Updates dialog - misaligned buttons
 * Fixed issue #3442: Commit & Push after amending a commit always results in a failed push
 * Fixed issue #3451: Turtle progress bar in process, but task is finish
 * Fixed issue #3450: Commit message after "Revert changes by these commits" suggests a single commit is reverted
 * Fixed issue #3461: Performing refresh on Commit window loses new branch name
 * Fixed issue #3446: No TortoiseGit Icon Overlays / Symbols in Drive Root Dir
 * Mark SSHAskPass and TortoiseGitPlink as DPIAware
 * PatchViewDlg: Fix Windows 10 border issue
 * Allow Refbrowser and Reflog to be minimized
 * Fixed issue #3480: Copy options in RefLog are misleading
 * Fixed issue #3497: Settings/Saved Data/URL-History/Del doesn't remove PUSH URLs:
 * Fixed issue #3466: Rebase checkboxes might disappear when resizing
 * Fixed issue #3493: Closing (cancelling) commit selection window while merging minimizes the Merge dialog
 * Fixed issue #3417: "ignore-on-commit" changelist disappears when committing on different folder
 * High DPI fixes (e.g., searchbar height/position in UDiff; remembering of dialog/slider/divider positions and column widths with changing DPI scalings)
 * LogDlg: Fix flickering on filtering
 * Fixed issue #3505: TortoiseGitProc and TGitCache crash on repositories with broken core.worktree path
 * SSHAskPass: Adjust window to text size
 * Fixed issue #3386: Line column in TortoiseGitUDiff might get cut off
 * Fixed issue #3454: Misaligned controls in Log Messages dialog

= Release 2.9.0 =
Released: 2019-10-31

== Changes ==
 * Support for Thesaurus was dropped
 * Thin-Pack option was dropped from fetch/pull dialog (enabled by default in Git)

== Features ==
 * Fixed issue #3355: Adding file name extension in the Export dialog
 * Update Scintilla to 4.2.0
 * Update libgit to 2.22.0 based on Git for Windows sources
 * Update TortoiseGitPLink to PuTTY PLink 0.73 (security fix, cf. https://www.chiark.greenend.org.uk/~sgtatham/putty/changes.html)
 * Update PuTTY binaries to 0.72
 * Allow to disable "Working Tree Changes" in log dialog (using advanced settings)
 * Update Hunspell to 1.7.0
 * Fixed issue #3363: Add option to show unlabeled most recent common ancestor between all branches in Revision Graph
   In the View menu you can now toggle the display of branchings and mergings.
   (This also fixes issue #2110: The Revision Graph is invalid if first commit does not contains the files)
 * Fixed issue #3379: Super-project-pointer should show in revision graph of submodule
 * Fixed issue #3421: Option to show Log IDs instead of SHA-1 in TortoiseGitBlame
 * Fixed issue #3343: Provide a confirm dialog instead of executing the revert operation directly
 * Ref Browse: Show date and author of annotated tag as well
 * Show whitespaces in patch views
 * Fixed issue #3414: Allow users to not display all tags on revision graph
 * Add find functionality to revision graph
 * Fixed issue #3427: FileDiffDlg: Provide a way to view the diff for a pull request branch (in diff options)
 * Fixed issue #3440: (GUI) Animation should stop when finished, not halt
 * Fixed issue #3395: TortoiseGit now uses the Windows "Default Application" framework for managing file associations and protocol handlers
 * Fixed issue #3436: Please document rolling back a file to a previous revision in Undo Changes

== Bug Fixes ==
 * Implement generic fix for "libgit2 returned the requested type does not match the type in ODB"
 * Fixed issue #3342: Windows Explorer context menu: TortoiseGit doesn't recognize local Git working copy if "gitdir-redirection" is used within same folder
 * Fixed issue #3349: View patch missing color
 * Fixed issue #3365: Ignore items by extension handles files/directories with no extension poorly
 * Fixed issue #3393: TortoiseGitIDiff crashes with a very small window size
 * Fixed issue #3397: Create Repository make a useless symlink on Windows 10
 * Fixed issue #3413: Putty Agent (pageant) unable to start when file "C:\Program" exists
 * Fixed issue #3429: Optimize progress output with multiple git commands
 * Fixed issue #3434: Commit dialog's "View Patch>>" shows nothing when dialog's right border is on the screen's right border
 * Fix potential crashes in TortoiseGitBlame when .mailmap support was enabled
 * Fix potential crash when log is still calculating diffs and rebase dialog loads
 * Prevent possible crash after rebase when writing to reflog fails
 * Fixed issue #3426: Ref Browse: Speed up display when having thousands of refs
 * TortoiseGitMerge: When ignoring comments in TMerge, ignore comment block markers inside strings
 * Fix start commit hook not working for repository hooks
 * Fix potential crashes when log is still loading and submodule diff is requested

= Release 2.8.0 =
Released: 2019-02-28

== Features ==
 * Update libgit to 2.19.0 based on Git for Windows sources
 * Fixed issue #2591: Enable accent coloring for search term matches in log messages and FileDiffDlg
 * LogDlg, FileDiffDlg, RefBrowserDlg: Allow to use more complex search expressions, see documentation
 * Fixed issue #3279: Browse References -> lacks capability to double click an item (now opens log by default)
 * Update Scintilla to 4.1.3
 * Fixed issue #3277: Start of rebase process doesn't show log tab by default
 * Fixed issue #3273: Show more information (beginning of commit subject) about commit parents in context menus
 * Fixed issue #3272: Revision Graph does not show the option to checkout a remote branch
 * Added the option to store hook configurations within the repository (/.tgitconfig) in order to share it with other developers
 * Fixed issue #3154: Decorate bare repository's folder with a Git icon
 * Update OGDF library to latest stable version (used for Revision Graph)
 * Make unified patch in temp folder read-only
 * Update apr to 1.6.5
 * Update libgit2 to version 0.28
 * Fixed issue #3304: Double click on stash list item does nothing, show log instead
 * Fixed issue #3305: Stash Changes/Save, then allow Stash Apply
 * Support opportunistic TLS for SendMailDlg
 * Improve documentation for alternative unified diff viewer configuration
 * TGitCache: Speed up scanning of folders with lots of unversioned files
 * BrowseRefsDlg: Allow to delete multiple remote branches in batch
 * Rebase: Document start, abort and finish in reflog
 * Add TortoiseGitUDiff to Open With list
 * Update editorconfig to 0.12.4
 * Fixed issue #3295: TortoiseGitPlink does not work with Git protocol ver. 2
 * Fixed issue #3290: Improve "Status/Check for modifications" documentation
 * Fixed issue #3228: Rebase: Add full support for empty commits (e.g., commits which become empty during conflict resolution)
 * Fixed issue #3189: Show progress bar when resolving lots of conflicts
 * Fixed issue #3318: More accurate git-svn detection
 * Fixed issue #1770: Add support for changelists
 * Fixed issue #3327: Clarify remote and remote-tracking branch
 * TGitCache: Significantly reduce disk access for requesting cached file statuses
 * FileDiffDlg: Correctly show renames (also also allow to filter by them)
 * Fixed issue #3206: Update shipped Notepad2 to Notepad2e

== Bug Fixes ==
 * Fixed issue #3250: GitWCRev: IsGitItem return true for item that had never been committed
 * Fixed issue #3251: GitWCRev.GetWCInfo COM object ignores file path (parameter 1)
   GitWCRev not honours the passed path and calculates the HasModifications/UnversionedFiles status according to the passed path
 * Fixed issue #3261: Review/Apply single patch does not work anymore if patch does not apply cleanly
 * Fixed issue #2541: Patches created from "Create patch file" in diff view/TortoiseGitMerge has invalid filepath
 * CommitDlg: commit.template did not honor "~/"
 * Fixed issue #3271: Document TortoiseGitProc.exe /command:merge /abort option
 * Fixed issue #3281: TortoiseGitUDiff preferences page clips out text in Russian translation
 * Fixed issue #3284: BrowseRefsDlg: Cannot compare annotated tag to working tree (libgit2 returned the requested type does not match the type in ODB)
 * Modified files, Revert, and Resolve dialogs did show all staged files regardless of selection
   The Commit dialog still shows all staged files, this is by design and required for commit to work properly (e.g., that no files get lost in a merge commit).
 * Fixed issue #3264: Remove tag can leave an empty folder in refs/tags
 * Fixed issue #3297: Missing URI-encode of %BUGID%-part by call of issue tracker URL
 * Fixed issue #3307: Abort Merge on a single file always results in a parameter error message
 * Fixed issue #3269: Git Command Progress window blank, hanging on commit (e.g., when auto gc is running)
 * Fixed issue #3039: Icon overlays don't update properly when committing after gc prune on the command line
 * Fixed issue #3316: Misleading message box after pull with rebase, when branch is behind origin/branch, but origin/branch=remote/origin/master
 * Fixed issue #3288: Commit window: text is cut when Russian localisation
 * Fixed issue #3317: merge-ods.vbs-script: Merged document in LibreOffice 6.1 deleted by the script
 * Fixed issue #3329: create tag with message results in fatal error if username contains space
 * Fixed issue #3330: Edit notes don't load correctly for stash commits and reflog dialog
 * Fixed issue #3331: "Putty Key:" label is too narrow for localization
 * RefLog: Remember last selected branch on refresh
 * Opening the credential helper settings page caused elevation logic to trigger
 * Improved detection of valid git repositories
 * Improved stability in various unusual cases

= Release 2.7.0 =
Released: 2018-08-19

== Changes ==
 * Git (for Windows) 2.11 or newer is now required

== Features ==
 * Fixed issue #3186: Bisect skip missing on dialogs and in automation and bisect docs
 * Fixed issue #3188: Add progress support for submodule clone
 * Fixed issue #3212: With Detached Head, Push Dialog has Local Branch filled with HEAD or Commit Hash
 * Fixed issue #3223: Format Patch: Set From and To for single commits
 * Lots of high DPI improvements
 * Fixes issue #2635: The font of git log is too small
 * Fixed issue #3240: Allow changing the similarity index threshold (using the advanced option "DiffSimilarityIndexThreshold")
 * Fixed issue #3227: Add support to git describe option --first-parent
 * Fixed issue #3187: Assume unchanged for submodule directory can't be undone in TGit
 * SyncDlg: Allow to open the separate dialog boxes for fetch, pull, push, stash changes and submodule update/sync when holding the shift key when clicking on the buttons

== Bug Fixes ==
 * Fixed issue #3167: Crash when aborting cherry-picks
 * Fixed issue #3164: TortoiseGit crashing on commit (with racy git situation and git lfs)
 * Fixed issue #2035: Can not un-check the menu item "Abort Merge" in Settings dialog
 * Fixed issue #3078: Faulty behaviour of "Commit" feature in "check for modifications"
 * Fixed issue #3184: Committing asks for user data although they are set via includeif
 * Fixed issue #3193: Not able to set alternative editor
 * Fixed issue #3195: TGitMerge tool is not saving color to correct Windows registry location
 * Fixed issue #3194: Commit message control launches links on selection
 * Fixed issue #3202: Deletion of inactive branch inside not main working copy fails
 * Fixed issue #3200: Problem when adding files to a worktree which is based on a bare repo
 * Fixed issue #3201: Frequent TGitCache crashes
 * Fixed issue #3197: Bad generated path while renaming file with changing folder
 * Fixed issue #3211: Push from detached head not possible when no local branch exists
 * Fixed issue #3210: index.lock left behind after refreshing working tree changes when using Git LFS
 * Fixed issue #3234: Shortcuts for Up/Down still work while rebasing
 * Fixed issue #3239: Properly indicate processing in diff dialog
 * Fixed an regression which caused a major slowdown in TGitCache in repos with lots of unversioned files

= Release 2.6.0 =
Released: 2018-02-17

This is planned to be the last version compatible with MsysGit 1.9.5 (i.e., Git for Windows < 1.9.5).

== Features ==
 * Fixed issue #3089: Show parent SHA1 on cherry picking a merge commit
 * Fixed issue #3052: Filename autocomplete in commit dialog ignores filenames starting with underscores
 * TortoiseGitMerge now uses native ribbon instead of MFC wrapped
   This results in a noticeable speed up (cf. issue #1616) and also fixes issues with rounded corners for maximized windows (cf. issue #1767)
 * Fixed issue #3107: Clean: Allow to remove orphaned submodules (i.e., clean -f -f)
 * Fixed issue #3126: Add an option to show all refs of a commit in the log (all refs are shown now by default)
 * Fixed issue #3116: Revision graph: add ability to delete branches
 * Fixed issue #3121: Create shorter branch names when checking out a commit
 * Update linked libraries:
   * pcre to 8.41
   * apr to 1.6.3 and apr-util to 1.6.1
 * Commit now informs the user if there is a conflict hint in the commit message (line starting with "# Conflicts:")
 * Fixed issue #3137: Add TortoiseGit to Win10 default program list
 * Fixed issue #3141: bisect: add good/bad continue options to progress dialog
 * Add support for github's new client protocol (x-github-client)
 * Fixed issue #3160: Close TortoiseGitBlame window by ESC key (you might need to reset keyboard shortcut settings manually)

== Bug Fixes ==
 * Fixed issue #3029: LogDlg: Action column icons painted over Graph or message columns when turned off or resized
 * Fixed issue #3042: Spelling and grammar errors in First Start Wizard
 * Fixed issue #3035: TortoiseGit 2.5.0.0 might crash in LogDlg after fetch or refreshing working tree status
 * Fixed issue #3050: TortoiseGitMerge UI: Context menu is not available on margin left to text any more
 * Fixed issue #3059: Right click in touch mode is not working
 * Fixed issue #3064: Commit dialog ignores "Select items automatically" when refreshing
 * Fixed issue #3036: Can not save changes in Settings -> Network after trying to add command-line option to the SSH-client
 * Fixed issue #3066: Message field needs vertical scrollbar in Create Tag dialog
 * Fixed issue #3033: Cannot view submodule log if repository sits under directory symlink
   Update libgit to 2.15 based on Git for Windows source.
 * Fixed issue #3055: Explorer crash when deleting two independent folders
 * Fixed issue #3047: When Log Messages window is narrow, Filter box placeholder text may cover up the Filter Types button
 * Fixed issue #3090: Show Log window stuck with "Fetching changed files..."
 * Fixed issue #3084: Improve info message for merge-doc.js and drop broken URL
 * Fixed issue #3085: merge-doc.js: Word 2007 does not make a three-way comparison and the documents are shown in wrong order
 * Fixed issue #3086: merge-doc.js: Merge document in word >=2010 leaves three open windows
 * Fixed issue #3096: Duplicate 'Save as...' context menu items appear when closing and opening 'View Patch' window
 * Fixed issue #3093: Icon overlay might show ignored directories containing files as modified
 * Fixed issue #3076: Commit dialog opens with incomplete rendering in Windows 7 classic theme
 * Fixed issue #3094: Diff command results in crash
 * Fixed issue #3041: Commit Window might freeze when clicking on the last modified header shortly after opening
 * Fixed issue #3061: MenuButton popup might show directly under mouse arrow
 * Fixed issue #3108: Versioned file in ignored folder causes wrong overlays
 * Fixed issue #3109: Bad greying out of outer paths (other paths with same prefix also match)
 * Fixed issue #3132: Post commit hook doesn't show up on settings dialog
 * Fixed issue #2990: SendmailDlg: Don't auto select entries when using arrow keys
 * Fixed issue #3134: Deletion of submodule does not allow user to select the deleted (red) submodule on commit
 * Fixed issue #3138: "Check for modifications", "Revert" and other dialogs do not work after git update to version 2.16.0: "fatal: empty string is not a valid pathspec"
 * Fixed issue #3139: Git SSH operations do not work after git update to version 2.16.0 if ssh URL contains a port
 * Fixed issue #3143: Remember last selection of "Show nested refs" when browsing references
 * Fixed issue #3152: TortoiseGitMerge: Single pane view as default
 * Fixed issue #3158: TortoiseGitProc.exe hangs with 100% CPU when displaying commit window
 * Fixed issue #3153: "Failed to parse config file" if .gitconfig or .gitmodules use CRLF and contain blank lines
 * Fixed issue #3155: Can't parse config or .gitmodules files if the encoding is UTF-8 BOM

== Known issues ==
 * Due to changes in Win 10 1709 TortoiseGit(Merge) might start up slowly or gets slower over time without the patch KB4058258 (OS Build 16299.214) released on 2018-01-31; check Windows update (cf. issue #3087).
 * Due to a bug in Windows 10 1709 the mouse might jump on Drag in Commit Dialog (cf. issue #3145)

= Release 2.5.0 =
Released: 2017-07-23

== Major change ==
 * VS2017 is used for building TortoiseGit
   On x64 versions of Windows, the TortoiseGit context menu and overlays won't show for pure 32-bit applications in their file-open/save dialogs until you install the 2015 C++-runtime for x86.
   https://www.microsoft.com/en-us/download/details.aspx?id=52685 (select the vc_redist.x86.exe file for download).

== Features ==
 * Fixed issue #2931: Make “ChangeList” grids in “Git synchronization” multi-selectable
 * Update Scintilla to 3.7.5
 * Fixed issue #2949: Don't hide "Show log" button when fetch/pull was not successful
 * Fixed issue #2619: Add basic support for "git worktree"
 * Fixed issue #2966: Do not need to confirm cancel out of commit when there are no changes left
 * Fixed issue #2861: Cloning a repository with many files tracked by git-lfs is extremely slow
 * Various High DPI optimizations
 * Update libgit to 2.13.1
 * Update zlib to 1.2.11
 * Update apr and apr-util
 * Fixed issue #2988: Add `Show/hide ignore local changes flagged files` in Log Dialog
 * Fixed issue #2999: Log dialog: Copy tag to clipboard
 * Fixed issue #2964: Blame: gloss over per-line commit reference if duplicated
 * Fixed issue #2429: "Abort merge" should allow to select "git reset --merge"
 * Fixed issue #2448: TortoiseGitBlame: Line Wrapping
 * Fixed issue #2550: Search functionality on message in the RefLog window
   CTRL+F and F3 already opened a search dialog, now there also is a search button
 * Fixed issue #2599: Confusing titles when resolving a rebase or a merge conflict
 * Fixed issue #3008: Allow to push individual tags
 * Fixed issue #2973: Allow to compare local and remote tags using SyncDlg
 * Fixed issue #2775: Fetch And Rebase doesn't rebase if nothing is fetched
   It's configurable now whether opening the rebase dialog is skipped if nothing was fetched or current HEAD is up2date or newer
 * Fixed issue #3016: Add context menus to the header views in three way diff mode to open TMerge again with the diff shown in the corresponding file
 * Fixed issue #2980: Since TortoiseGit 2.4.0 the icon overlays are case sensitive. if you really want to change this default, you can disable the advanced setting "OverlaysCaseSensitive". This is, however, not the default and not recommended as some git tools such as "git log" are case sensitive on paths and might show an incomplete history.
 * FileDiffDlg: Allow to use alternative diff tool by pressing Shift
 * Allow to view diff on Delete/Modified conflicts
 * Sync smart tab detection code with TortoiseSVN
 * Ask before pushing all local branches to a remote
 * TGitBlame: Allow to search both directions
 * LogDlg and CommitDlg: Provide more copy options
 * GitStatusListCtrl: Use logical (stable) sort if enabled

== Bug Fixes ==
 * Fixed issue #2909: Commit window unclosable after clicking "No" and "do not ask again"
 * Fixed issue #2911: Doing Add on repository root fails with libgit2 returned invalid path"
 * Fixed issue #2791: Start Bisect UI incomplete
 * Update PuTTY to 0.70 (security fix, cf. https://www.chiark.greenend.org.uk/~sgtatham/putty/changes.html)
 * Fixed issue #2935: Icon overlay not shown for files on network UNC paths
 * Fix possible crash in TortoiseGitMerge when applying patch
 * Fixed issue #2942: Can't update Remote Branch of Pull dialog with Browse references dialog
 * Fixed issue #2951: Graphics corruption on taskbar overlay with UI scaling
 * Fixed issue #2945: Rebase dialog should remember the last position of the divider
 * Fixed issue #2947: Reinitializing a repository using "git init --separate-git-dir" turns all overlay icons to added
 * Allow snippets to include new lines (using "\n" notation)
 * Spell checker wrongly marked styled words as misspelled (e.g. _example_)
 * Fixed issue #2960: libgit2 fails to resolve absolute symlinks
 * Fixed issue #2963: Rebase dialog does not change "Start (FastFwd)" button during rebase process
 * Fixed issue #2968: Active urls in output windows opened when hitting ESC
 * Fixed issue #2985: TortoiseGit hangs when prematurely double clicking on "Please wait..."
 * Fixed issue #2979: gitignore patterns are always treated case sensitively for overlay icons
 * Fixed issue #2998: Resizing dialogs might lead to extension of clickable checkox area
 * Significant TGitCache rewrite which reduces disk access and fixes other issues:
   * Fixed issue #2989: TGitCache: Significantly reduce refresh requests send to Windows Explorer (causing Explorer to freeze)
   * Fixed issue #2766: TGitCache: Icon Overlay might show ignored files as non-versioned
   * Fixed issue #2818: TGitCache: overlays sometimes blink in and out of existence for several minutes at a time
   * Fixed issue #1242: TGitCache might fall into an (endless) refresh loop
   * Symlinks are not shown as modified any more
 * Missing index is not an error condition, but need to be handled like an empty index
 * Shell overlay cache: Don't show .git file with unversioned icon
 * Fixed issue #3002: Push underlined hotkey is missing in log window.
 * Fixed issue #3005: TortoiseGit does not support cloning local svn repositories
 * Fixed issue #3011: clone: --bare and --origin options are incompatible
 * Fixed issue #3013: Error message if remote Git output contains non-ASCII chars
 * Fixed issue #3014: MergeDlg: Commit dialog is opened instead of resovle dialog after resolve button pressed
 * Fixed issue #2926: Don't report an error for invalid remote symbolic references
 * Fixed issue #2955: LogDlg: infinite line to parent when initial commit is branched
 * Fixed issue #3017: Spaces at the beginning of the URL breaks pushes
 * Fixed issue #2258: Autocomplete for Remote URL box in Sync screen doesn't work
 * Fixed issue #2976: After setting the config `include.path` key, can't delete the branch which is tracking the remote branch
 * Fix possible crash if "git.exe diff-index" exits with an exit-code != 0, but no error message
 * Do not append empty pathspec to "git clean"
 * TGitBlame: Implement double buffering
 * LogDlg: Remember scroll position when refreshing working tree status
 * Fixed issue #3028: Error when using TortoiseGit cli diff command with new added file in commit
 * /startrev: and /endrev: parameters of /command:diff are no longer mixed up

= Release 2.4.0 =
Released: 2017-01-31

== Major change ==
* TGitCache and icon overlays are case sensitive now

== Features ==
 * Fixed issue #2505: Add support for bisect skip
 * Fixed issue #2757: Allow to use quotes in command line arguments, like /logmsg:"Some text ""Quoted text"" another text"
 * Fixed issue #2849: Optimize include and exclude paths for context menu and overlay icons
   We synced the include/exclude paths code with TortoiseSVN. Now you can exclude paths in an included path.
   Some people might need to update their include/exclude paths, see our manual for more information.
 * Fixed issue #2136: LogDlg: Indicate that the View and Walk Behavior buttons contain a menu
 * Fixed issue #1635: Add option to set TortoiseGitMerge foreground text colors
 * Fixed issue #2586: Integration of further hooks: pre-rebase and post-commit
 * Fixed issue #2444: Drag and drop on commit dialog to include files in the list for committing
 * Browse References Dialog: Allow to filter for merged and unmerged branches
 * Fixed issue #2273: Remember the width of the "view patch" window
 * Fixed issue #2710: Allow start-commit hook to prevent the Commit dialog from showing
 * Fixed issue #2865: Clickable URLs in TortoiseGit output window
 * Fixed issue #2154: Copy to clipboard function in show log window doesn't include annotated tag or notes messages
 * Fixed issue #1668: Allow submodules to be removed ("Delete" is now available for submodules)
 * Update libgit2 to 0.25.1
 * The shipped libgit2 uses the CrLf filter logic from Git >= 2.9
 * Fixed issue #2863: Increase text box size limit for command progress dialog and make it configurable
 * Fixed issue #2274 and issue #2750: Add advanced option for controlling which date/time is used for squashed commits (setting: SquashDate)
   1: Use date of last commit, 2: Use current date, 0: Use time of first commit into which others are squashed (default)
 * Fixed issue #2633: Check for Modifications dialog doesn't refresh after commit
 * Fixed issue #1656: Add "dcommit" to change sets in "log messages"
 * Fixed issue #2741: TortoiseGitBlame: Allow to limit blame on first parents
 * Fixed issue #2826: Highlight commit to which the parent repo points to in the log for submodules (named: super-project-pointer)
 * Added a first start wizard which can be re-run from TortoiseGit settings
 * Fixed issue #2593: Hitting escape closes the commit window without any attention message
 * Fixed issue #2702: File selection dialog should not open for Add if only files are selected
 * Fixed issue #1749: Create Patch Serial: Remember "Since" branch
 * Fixed issue #2264: Insert new items into interactive rebase and cherry-pick process
 * Fixed issue #2456: Allow to compare change sets in log
 * Updated libgit to 2.11
 * Updated pcre to 8.40
 * Several high DPI optimizations
 * Fixed issue #2889: TortoiseGitMerge: Show inline diffs in one-pane-view mode as well, at least for single line changes
 * Fixed issue #2894: Enable/disable check boxes for hook scripts
 * Enable/disable check boxes for bugtraq plugins
 * Fixed issue #2283: Improve symbols for "Symbolize ref names"
 * Fixed issue #2746: SubWCRev equivalent required: GitWCRev added
 * Fixed issue #2082: RebaseDlg: Reorder commits via drag'n'drop
 * Fixed issue #2210: Do not allow merging from the current branch to the current branch

== Bug Fixes ==
 * Fixed issue #2837: Fixed layout issues on settings dialog
 * Fixed issue #2839: The dialog "check for updates" has a resize issue
 * Fixed issue #2845: Sticky button when resizing the "Rename dialog"
 * Fixed issue #2846: Spell checker won't add unknown words to dictionary. The dictionaries are now saved as UTF-8.
   If you have non ascii chars in your dictionary and want to keep those, you need to manually convert these to UTF-8.
   The dictionaries can be found in %APPDATA%\TortoiseGit\*.dic.
 * Fixed issue #2850: The installer does not completely support high-contrast-mode
 * Fixed issue #2853: Commit message autocompletion failed sometimes for words with different casing
 * Fixed issue #2851: Switching high-contrast-mode on or off, does not cause change of used UI colors
 * Fixed issue #2829: Remembering the last selected line might not work when a conflict was manually resolved
 * Fixed issue #2868: Show changes as unified diff might fail (using Cygwin git)
 * /command:showcompare /unified did not honor path filters correctly
 * Fixed issue #2870: Save unified diff can cause TortoiseGit to not respond
 * Fixed issue #2217: LogDlg: Refresh working tree status and file list after changes to working tree
 * Fixed issue #2833: Pull with 'pull.rebase=preserve' does rebase on invalid upstream
 * Fixed issue #2859: Cannot clone URLs which contain non-ASCII chars with Git for Windows 2.10.1 and 2.10.2
 * Fixed issue #2872: Rebase local/remote reversed for tree conflicts (delete/modify conflicts)
 * Fixed issue #2491: Optimize way for creating temporary files in order to improve compatibility with certain backup softwares
 * Fixed issue #2875: Fixed error in settings hint text
 * Fixed issue #2878: SplitContainer redraw issues in Cherry Pick dialog
 * Fixed issue #2877: Git fetch all with rebase might produce error
 * Fixed issue #2874: Horizontal scroll reversed in TortoiseGitMerge
 * When showing an autocompletion list, don't bail out if one is already shown but just update it
 * Fixed issue #2887: ListView flickering in Browse References dialog
 * Fixed issue #2891: "Show log" on a repo with 200k files is extremely slow due to each file attributes being queried individually
   This also improves submodule support as we rely on the directory/file information we got from git now.
 * Fixed issue #2896: Blame revisions ListView selection and flickering issues
 * Fixed issue #2883: Improve wording for our "needs merge" hint in commit dialog
 * Fixed issue #2898: Branch name forced to be lower what leads to pull error
 * TGitCache: Do not accidentally report up status of submodules to parent repo if not enabled
 * TGitCache: Prevent more FILE_SHARE_VIOLATIONS for deleting files
 * Fixed issue #497: TGitCache.exe won't let user delete folder
 * Fixed issue #2899: Fall back to %USERPROFILE% if %HOMEDRIVE%%HOMEPATH% is not a directory for %HOME% detection as Git for Windows does
 * Fixed issue #2664: Windows explorer slow/very long delays with shell extension enabled

= Release 2.3.0 =
Released: 2016-10-01

== Features ==
 * Fixed issue #2755: TortoiseGitMerge: find dialog box does not remember desktop location between invocations
 * When an alternative/external diff or merge tool is configured, you can now press the shift key while opening the diff to fall back to TortoiseGitMerge
 * Fixed issue #2812: Better indicate conflicts on stash pop and allow to automatically show changes
 * Fixed issue #2439: Add 'show branches this revision is on' to the blame window
 * Fixed issue #2026: Allow to navigate to branch shown on "Show branches this commit is on" dialog
 * Fixed issue #2806: Allow to turn off tooltips in file lists (in advanced settings using ShowListFullPathTooltip)
 * Fixed issue #2475: Allow to use mailmap translations in log dialog
 * Fixed issue #2816: Add mnemonics to Reset, Switch, Merge Abort and Export dialogs
 * Fixed issue #491: Rename dialog should have a browse button
 * TortoiseGit now uses latest libgit2 which supports git index version 4
 * Added support for GIT_ASK_YESNO wrapper
 * Updated libgit to 2.10.0
 * Fixed issue #2830: Log from Repository Browser should use selected branch by default
 * Fixed issue #2829: Add, Commit, Rebase, Repository Status, Resolve, and Revert dialogs try to remember the last selected line on refresh (e.g., after resolving a conflict)
 * Rebase and Commit Dialog: When clicking on OK or resolve and a conflicted file is detected, jump to it (aka goto next conflict)

== Bug Fixes ==
 * Fixed issue #2789: Sync Dialog In ChangeList tab auto-resize column not optimal
 * Fixed issue #2792: Mouse pointer disappears for the log window's context menu under Windows 8.1 and Windows 10
 * Fixed issue #2800: Authentication with non-ascii password fails
 * Fixed issue #2798: Commit message autocompletion doesn't work with UTF-8 encoded files
 * Fixed issue #2797: RebaseDlg: Make branch selectors adjust with resized dialog
 * Autocompletion of filenames with umlauts in the commit dialog did not work
 * Fixed issue #2799: Column sizes in "Browse references" dialog are not remembered
 * Try harder to not report unchanged files as changed (if modification time changed)
 * Fixed issue #2809: TortoiseGitMerge: Block Control Button is always disabled on conflict resolution
 * Fixed issue #2814: "Git Check for modifications" and Commit dialog runs batch files for unversioned or ignored files
 * Fixed issue #2815: TortoiseGitMerge might hang with ignore comments enabled
 * Fixed issue #2557: TortoiseGit Update closes windows explorer but might not reopen it

= Release 2.2.0 =
Released: 2016-07-02

== Features ==
 * Updated libgit to 2.8.3
 * Fixed issue #2773: Directory renames should be displayed shorter
 * GitStatusList now automatically adjusts the width of columns. This can be disabled by manually sizing it.
 * Fixed issue #2705: TGIT should allow cloning and/or creating from within a non-empty repository
 * Update Scintilla to 3.6.6
 * Fixed issue #2271: "Check For Updates" dialog should be resizable
 * Fixed issue #1953: Add drag handler to Repository Browser
 * Fixed issue #2770: Include complete relative path in TortoiseGitMerge

== Bug Fixes ==
 * Fixed issue #2745: TortoiseGit 2.1 crashes on broken git config
 * Fixed issue #2759: Swapped THEIRS and MINE in cherry-pick conflict dialogs and context menus
 * Fixed issue #2767: The online help of Settings->Git->Remote should explain the "Push Default" checkbox
 * Fixed issue #2772: Comparing with added file might result in comparison with empty file
 * Fixed issue #2774: Pull dialog with Russian LangPack has three defficiencies
 * Fixed issue #2783: "Delete and add to ignore list" does not work when more than 16 files are selected
 * Fixed issue #2740: Order of compared references in revision graph is labelled inverted
 * Fixed issue #2785: Rebase/Cherry-pick with conflict in renamed file fails
 * Fixed issue #2714: TortoiseGitMerge should redraw if font is changed
 * Fixed issue #2756: TortoiseGitMerge: Regex Filter doesn't filter from "Previous diff", "Next diff" operation
 * Fixed issue #2736: stash list/pop missing when refs are packed
 * /revision1: and /revision2: parameters of /command:showcompare are no longer mixed up

= Release 2.1.0 =
Released: 2016-03-26

== Changes ==
 * We disabled the stripping of comments on commit messages by default again (see issue #2715)

== Features ==
 * Update PuTTY to 0.67
 * Fixed issue #2733: Hide commit button after file add when invoked from commit dialog
 * Fixed issue #2734: When pull.rebase is set, start rebase just after fetch, not after OK button
 * Fixed issue #2731: Improved autolist.txt regex for C# files
 * Update libgit2 to 0.24.0
 * Update Scintilla to 3.6.4

== Bug Fixes ==
 * Fixed issue #2719: Commit & Push in CommitDlg doesn't respect default remote and pushbranch settings
 * Fixed issue #1902: CommitDlg: Do not lose SQUASH_MSG contents
 * Fixed issue #2732: Commit dialog: Message field should have focus (when patch is shown)
 * Fixed issue #2730: Pull with rebase with preserve merges not working for noops
 * Fixed issue #2728: Cherry Pick is not working in case of conflict and empty message
 * Fixed issue #2715: Cannot commit with a commit message starting with a hash (#) character
 * Updated libgit to 2.5.5 which includes fixes for CVE-2016-2315 and CVE-2016-2324
 * Fix the credential helper settings dialog

= Release 2.0.0 =
Released: 2016-02-29

== Changes ==
 * Custom dictionaries are no longer loaded when located in %PROGRAMFILES%\TortoiseGit or %PROGRAMFILES%\TortoiseGit\bin-directory
   Must be in  %APPDATA%\TortoiseGit\dic or %PROGRAMFILES%\TortoiseGit\Languages folder (former has priority)
 * Dropped TGitCacheCheckContent configuration setting, please use TGitCacheCheckContentMaxSize instead (settings will be automatically migrated)
 * Pre- and post-push hooks do not get the path as first parameter any more
 * Git for Windows 1.9.5 or newer is now required
 * TortoiseGit now applies the same whitespace and new line sanitizing rules as git core for commit messages by default
 * TortoiseGit now strips commented lines (starting with #) on commit messages by default
 * We changed the version schema to X.Y.Z, where X is incremented for major changes, Y for every stable release, and Z!=0 represents preview releases

== Features ==
 * Fixed issue #2641: Commit: Pre-select first item from "Changes made" list
 * Allow to reset stored decisions (cf. issue #2640)
 * Fixed issue #2643: Set branch description on its creation
 * Fixed issue #1629: Have the push dialog opened via right-click in log default to branch that was actually clicked on
 * Update TortoiseGitPlink to version 0.66
 * Fixed issue #943: Allow to use keyboard shortcuts in Git progress dialog (e.g., ALT+R for ReCommit after commit)
 * Fixed issue #2314: Allow to preserve merges on rebase
 * Fixed issue #2673: Display tracked remote URL in folder properties
 * Fixed issue #2630: TGitBlame: Allow to blame files of different working trees w/o restarting
 * Fixed issue #2679: Unnecessary horizontal scrollbar is shown in case logwidthmarker is set
 * Rebase dialog now honors rebase.autostash=true
 * Fixed issue #2270: Print a warning on a merge commit, so that changes are not unchecked unintentionally
 * Fixed issue #2310: Add support for notes.rewrite.rebase
 * Fixed issue #2629: "Browse References Dialog" save sort column + order
 * Fixed issue #2678: Filter out special ref names in log graph
 * Fixed issue #2692: Add support for pull.rebase and branch.name.rebase
 * Fixed issue #2701: Add and Revert should respect Autoclose settings and not show any dialog boxes
   Maybe we introduce finer grained auto close levels later.
 * Fixed issue #1899: Support cherry-picking merge revisions
 * Fixed issue #2551: Allow to create patches w/o a/ and b/ prefixes
 * Fixed issue #2302: One button to do Commit & push
 * Fixed issue #527: Fix the dialog after commit for us to be able to continue committing
 * Fixed issue #2697: Display "In Commits" and "In ChangeList" tabs for Fetch&Rebase in Sync dialog
 * Fixed issue #2484: Recursive option is not remembered in clone dialog
 * Fixed issue #2259: SyncDlg: Allow to fetch all remote references of a specific remote instead of a single branch (Fetch all refs)
 * Fixed issue #1130: Sync dialog forgets the remote branch every time (ask whether to store a tracked branch)

== Bug Fixes ==
 * Fixed issue #2647: TortoiseGitBlame does not display files correctly with mixed line endings (such as CRCRLF)
 * Fixed issue #2650: Empty ListViews drawing issue
 * Fixed issue #2662: Border line in commit text boxes is shown 2 characters past the specified width
 * Fixed issue #2660: No colors in git.exe progress dialog since 1.8.16
 * Fixed issue #2646: Library broken in Windows 10
 * Fixed issue #2670: LogDlg: cannot paste to "Filter paths"
 * Fixed issue #2676: Swapped Theirs and Mine in Edit conflicts outside of rebase dialog on rebasing
 * Fixed issue #2690: Failed to Show log from repository browser when that repository is located on a drive
 * Fixed issue #2655: Resolve does not work on multiple selection during deleted-modifed conflict resolution
 * Fixed issue #2668: TortoiseGit commit with git-lfs files, show me a error: ".git/index.lock" file exist
 * Fixed issue #2638: TGitCache crashes on a broken repo (out of bounds read in libgit2)

In order to find the list of changes for releases before 2.0.0, please refer to Changelog-pre2.0.txt
